﻿using UnityEngine;
using System.Collections;

public class Arrangement : MonoBehaviour {

	public GameObject prefabPlatformStandard;
	public GameObject prefabPlatformPassThru;

	public GameObject[] prefabBonuses;
	public GameObject[] prefabHazards;

	public void Build()
	{
		int childCount = transform.childCount;
		for( int i = 0; i < childCount; ++i ) {
			GameObject child = transform.GetChild (i).gameObject;

			GameObject obj = null;
			if( child.name.StartsWith("Standard") ) {
				obj = (GameObject)Instantiate (prefabPlatformStandard, child.transform.position, Quaternion.identity);
			}
			else if( child.name.StartsWith("PassThru") ) {
				obj = (GameObject)Instantiate (prefabPlatformPassThru, child.transform.position, Quaternion.identity);
			}
			else if( child.name.StartsWith("Bonus") ) {
				if( Random.value < .25f ) {
					obj = (GameObject)Instantiate (prefabBonuses[ Random.Range (0, prefabBonuses.Length) ], child.transform.position, Quaternion.identity);

					if( Random.value < .5f ) {
						obj.transform.localScale = new Vector3(-1, 1, 1);
					}
				}
			}
			else if( child.name.StartsWith("Hazard") ) {
				if( Random.value < .75f ) {
					obj = (GameObject)Instantiate (prefabHazards[ Random.Range (0, prefabHazards.Length) ], child.transform.position, Quaternion.identity);
				}
			}

			child.SetActive (false);
			if( obj != null ) {
				obj.transform.parent = transform;
			}
			else {
				Debug.Log ("No obj for child " + child.name);
			}
		}
	}
}
