﻿using UnityEngine;
using System.Collections;

public class CameraControl : MonoBehaviour {

	public GameObject objectToFollow;

	Player player;
	WorldGen worldGen;

	public bool demo = false;

	const float ascentSpeed_easy = 0.5f;
	const float ascentSpeed_medium = 1.0f;
	const float ascentSpeed_hard = 1.5f;
	const float ascentSpeed_brutal = 2.0f;
	const float ascentSpeed_impossible = 3.0f;

	float ascentSpeed = ascentSpeed_easy;

	WorldGen.ArrangementInfo.Type currentLevel = WorldGen.ArrangementInfo.Type.Easy;

	// Use this for initialization
	void Start () {
		GameObject playerObj = GameObject.Find ("Player");
		if( playerObj != null ) {
			player = playerObj.GetComponent<Player>();
		}
		worldGen = GameObject.Find (".WorldGen").GetComponent<WorldGen>();
	}
	
	// Update is called once per frame
	void Update () {
		if( player == null || player.isPlayerDead || demo ) {
			ascentSpeed = ascentSpeed_easy / 2;
		}

		float speed = ascentSpeed;
		if( objectToFollow != null && objectToFollow.transform.position.y - transform.position.y > 1 ) {
			speed = 3;
			if( objectToFollow.transform.position.y - transform.position.y > 3 ) {
				speed = 10;
			}
		}

		transform.position += new Vector3(0, speed * Time.deltaTime);

		if( worldGen != null && player != null ) {
			WorldGen.ArrangementInfo.Type level = worldGen.GetCurrentLevel ();
			if( level != currentLevel && !player.isPlayerDead ) {
				Debug.Log ("Increasing difficulty to " + level + " (current level: " + worldGen.currentLevel + ")");

				switch(level)
				{
				case WorldGen.ArrangementInfo.Type.Medium: ascentSpeed = ascentSpeed_medium; break;
				case WorldGen.ArrangementInfo.Type.Hard: ascentSpeed = ascentSpeed_hard; break;
				case WorldGen.ArrangementInfo.Type.Brutal: ascentSpeed = ascentSpeed_brutal; break;
				case WorldGen.ArrangementInfo.Type.Impossible: ascentSpeed = ascentSpeed_impossible; break;
				}

				currentLevel = level;
			}
		}
	}
}
