﻿using UnityEngine;
using System.Collections;

public class MobSpeak : MonoBehaviour {

	public TextMesh text;
	public GameObject bubble;

	float randomChance = .0095f;

	float bubbleTime = 5;

	Player player;
	int deathText = 0;

	// Use this for initialization
	void Start () {
		bubble.SetActive (false);
		player = GameObject.Find ("Player").GetComponent<Player>();
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		if( player.isPlayerDead && deathText == 0 ) {
			randomChance = 0.025f;
		}

		if( bubbleTime > 0 ) {
			bubbleTime -= Time.deltaTime;
			if( bubbleTime < 0 ) {
				bubble.SetActive (false);
			}
		}
		else if( Random.value < randomChance ) {

			if( Random.value < .5 ) {
				bubble.transform.localScale = new Vector3(-1, 1, 1);
				text.transform.localScale = new Vector3(-1, 1, 1);
			}
			else {
				bubble.transform.localScale = new Vector3(1, 1, 1);
				text.transform.localScale = new Vector3(1, 1, 1);
			}

			bubble.transform.localPosition = new Vector3((float)Random.Range (-4, 2), 0, 0);

			if( player.isPlayerDead ) {
				switch(deathText++)
				{
				case 0: text.text = "We Got Him!"; break;
				case 1: text.text = "Rip His\nHead Off!"; break;
				case 2: text.text = "We're\nFinally Safe!"; break;
				case 3: text.text = "He Almost\nKilled Us!"; break;
				case 4: text.text = "The Vicious\nBeast is Dead!"; break;
				case 5: text.text = "We Saved\nThe Town!"; break;
				case 6: text.text = "That Was\nClose!"; break;
				case 7: text.text = "Good Wins\nAgain!"; break;
				case 8: text.text = "That's One\nLess Monster"; break;
				case 9: text.text = "It's About\nTime!"; randomChance /= 4.0f; break;
				case 10:text.text = "Rabble Rabble"; break;
				case 11:text.text = "I'm Hungry"; randomChance *= 50; break;
				case 12:text.text = "Me Too\nLet's Eat"; randomChance /= 50; break;
				case 13:text.text = "You're Still\nReading These?"; break;
				case 14:text.text = "You Can Play\nAgain, Y'Know?"; break;
				case 15:text.text = "What Are You\nWaiting For?"; break;
				case 16:text.text = "Weirdo"; break;
				case 17:text.text = "How Long Can\nWe Keep This Up?"; break;
				case 18:text.text = "Hope You\nHad Fun"; break;
				case 19:text.text = "Thanks For\nPlaying!"; break;
				case 20:text.text = "That's All\nWe Have"; break;
				case 21:text.text = "Seriously,\nRestart Already"; break;
				case 22:text.text = "Is This The\nBest You Can Do?"; break;
				case 23:text.text = "Okay, We're Going\nHome Now"; break;
				case 24:text.text = "Goodbye"; break;
				default: return;
				}

				bubbleTime = 1.75f;
			}
			else {
				switch(Random.Range (0, 15))
				{
				case 0: text.text = "Get Him!"; break;
				case 1: text.text = "Kill The\nBeast!"; break;
				case 2: text.text = "He's Getting\nAway!"; break;
				case 3: text.text = "DEATH!"; break;
				case 4: text.text = "We Want\nBlood!"; break;
				case 5: text.text = "Destroy Him!"; break;
				case 6: text.text = "RAARGHH!"; break;
				case 7: text.text = "Slaughter!"; break;
				case 8: text.text = "Think Of\nThe Children"; break;
				case 9: text.text = "Oh The\nHumanity!"; break;
				case 10:text.text = "Hurry Up!"; break;
				case 11:text.text = "Outta My Way!"; break;
				case 12:text.text = "We Want\nBlood!"; break;
				case 13:text.text = "Blood & Guts!"; break;
				default: text.text = "Monster Bad\nMob Good"; break;
				}
				bubbleTime = 3;
			}

			bubble.SetActive (true);
		}
	}
}
