﻿using UnityEngine;
using System.Collections;

public class MoveTo : MonoBehaviour {

	public Transform moveTo;
	public float time = 1;
	public float delay = 0;

	Vector3 origin;
	float currentTime = 0;

	// Use this for initialization
	void Start () {
		origin = gameObject.transform.position;
	}
	
	// Update is called once per frame
	void Update () {
		if( delay > 0 ) {
			delay -= Time.deltaTime;
			if( delay <= 0 ) {
				delay = 0;
				origin = gameObject.transform.position;
			}
			return;
		}
	
		currentTime += Time.deltaTime;

		Vector3 dest = new Vector3(moveTo.transform.position.x, moveTo.transform.position.y, origin.z);
		transform.position = Vector3.Lerp (origin, dest, currentTime / time);
	}
}
