﻿using UnityEngine;
using System.Collections;

public class SoundManager : MonoBehaviour {

	static SoundManager _inst = null;
	AudioSource source;
	AudioSource soundtrack;

		public static SoundManager instance
	{
		get {
			if( _inst == null ) {
				GameObject obj = new GameObject(".SoundManager");
				_inst = obj.AddComponent<SoundManager>();
				_inst.source = obj.AddComponent<AudioSource>();

				GameObject bgObj = new GameObject(".SoundManagerBackground");
				_inst.soundtrack = bgObj.AddComponent<AudioSource>();
				DontDestroyOnLoad (obj);
				DontDestroyOnLoad(bgObj);

				GameObject worldGenObj = GameObject.Find (".WorldGen");
				if( worldGenObj ) {
					_inst.soundtrack.clip = worldGenObj.GetComponent<WorldGen>().audioSoundtrack;
					_inst.soundtrack.Play ();
					_inst.soundtrack.loop = true;
					_inst.soundtrack.volume = .5f;
				}
			}
			return _inst;
		}
	}

	public void Startup()
	{}

	public void Play( AudioClip clip, bool force = false )
	{
		if( source.isPlaying && !force) {
			return;
		}
		source.clip = clip;
		source.Play ();
	}


	// Use this for initialization
	void Start () {
	
	}
	
	// Update is called once per frame
	void Update () {
	
		if( Input.GetKeyDown(KeyCode.M) ) {
			if( _inst.soundtrack.volume == 0 ) {
				_inst.soundtrack.volume = .5f;
			}
			else {
				_inst.soundtrack.volume = 0;
			}
		}
		if( Input.GetKeyDown(KeyCode.S) ) {
			if( _inst.source.volume == 0 ) {
				_inst.source.volume = 1;
			}
			else {
				_inst.source.volume = 0;
			}
		}

	}
}

